<template>
  <el-dialog :visible.sync="visible" :title="!dataForm.ptsid ? $t('add') : $t('update')" :close-on-click-modal="false" :close-on-press-escape="false">
    <el-form :model="dataForm" :rules="dataRule" ref="dataForm" @keyup.enter.native="dataFormSubmitHandle()" :label-width="$i18n.locale === 'en-US' ? '120px' : '80px'">
          <el-form-item label="" prop="zntid">
          <el-input v-model="dataForm.zntid" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="name">
          <el-input v-model="dataForm.name" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="parentid">
          <el-input v-model="dataForm.parentid" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="selectid">
          <el-input v-model="dataForm.selectid" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="link">
          <el-input v-model="dataForm.link" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="thumbnail">
          <el-input v-model="dataForm.thumbnail" placeholder=""></el-input>
      </el-form-item>
          <el-form-item label="" prop="sort">
          <el-input v-model="dataForm.sort" placeholder=""></el-input>
      </el-form-item>
          </el-form>
    <template slot="footer">
      <el-button @click="visible = false">{{ $t('cancel') }}</el-button>
      <el-button type="primary" @click="dataFormSubmitHandle()">{{ $t('confirm') }}</el-button>
    </template>
  </el-dialog>
</template>

<script>
import debounce from 'lodash/debounce'
export default {
  data () {
    return {
      visible: false,
      dataForm: {
        ptsid: '',
        zntid: '',
        name: '',
        parentid: '',
        selectid: '',
        link: '',
        thumbnail: '',
        sort: '',
        creator: '',
        createDate: ''
      }
    }
  },
  computed: {
    dataRule () {
      return {
        zntid: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        name: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        parentid: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        selectid: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        link: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        thumbnail: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
        sort: [
          { required: true, message: this.$t('validate.required'), trigger: 'blur' }
        ],
      }
    }
  },
  methods: {
    init () {
      this.visible = true
      this.$nextTick(() => {
        this.$refs['dataForm'].resetFields()
        if (this.dataForm.id) {
          this.getInfo()
        }
      })
    },
    // 获取信息
    getInfo () {
      this.$http.get(`/cniyv/cniyvarticletype/${this.dataForm.id}`).then(({ data: res }) => {
        if (res.code !== 0) {
          return this.$message.error(res.msg)
        }
        this.dataForm = {
          ...this.dataForm,
          ...res.data
        }
      }).catch(() => {})
    },
    // 表单提交
    dataFormSubmitHandle: debounce(function () {
      this.$refs['dataForm'].validate((valid) => {
        if (!valid) {
          return false
        }
        this.dataForm.thumbnail =  this.$refs['uploadImg'].imgSrc
        this.$http[!this.dataForm.ptsid ? 'post' : 'put']('/cniyv/cniyvarticletype/', this.dataForm).then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg)
          }
          this.$message({
            message: this.$t('prompt.success'),
            type: 'success',
            duration: 500,
            onClose: () => {
              this.visible = false
              this.$emit('refreshDataList')
            }
          })
        }).catch(() => {})
      })
    }, 1000, { 'leading': true, 'trailing': false })
  }
}
</script>
